
#include <stdio.h>    /* Standard input/output definitions */
#include <stdint.h>   /* Standard types */
#include <string.h>   /* String function definitions */
#include <unistd.h>   /* UNIX standard function definitions */
#include <fcntl.h>    /* File control definitions */
#include <errno.h>    /* Error number definitions */
#include <termios.h>  /* POSIX terminal control definitions */
#include <sys/ioctl.h>
#include <getopt.h>
#include <sys/ioctl.h>
#include "stdio.h"


#include <iostream>
#include "CCoreMIDI.h"

#include <stdint.h>   /* Standard types */

#include <assert.h>
#include <pthread.h>



int serialport_init(const char* serialport, int baud);
int serialport_writebyte(int fd, uint8_t b);
int serialport_write(int fd, const char* str);
int serialport_read_until(int fd, char* buf, char until);


unsigned char  notemap[8][8] = 
{ 
{24,26,28,29,31,33,35,}, 
{24+12,26+12,28+12,29+12,31+12,33+12,34+12,35},
{24+24,26+24,28+24,29+24,31+24,33+24,34+24,35+24},
{24+36,26+36,28+36,29+36,31+36,33+36,34+36,35+36},
{24+48,26+48,28+48,29+48,31+48,33+48,34+48,35+48},
{24+60,26+60,28+60,29+60,31+60,33+60,34+60,35+60},
{24+72,26+72,28+72,29+72,31+72,33+72,34+72,35+72},
{24+84,26+84,28+84,29+84,31+84,33+84,34+84,35+84}, };

unsigned char  toggleMp[8][8] = 
{ 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, };


unsigned char  toggleMpSeq[8][8] = 
{ 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, 
{0,0,0,0,0,0,0,}, };

unsigned char  seqMap[8]={24,26,28,29,31,33,35,36};


CCoreMIDI *_cCoreMIDI;
CCoreMIDIEndpointRef _fromMonomeSerial;
CCoreMIDIEndpointRef _toMonomeSerial; 
CCoreMIDIEndpointRef endpointRef;


int n;
char c;

bool is_running=true;
int fd = 0;
int baudrate = B9600;  // default
char buf[256];
int rc;
int tem;
int mode=3;
bool firstSeq=true;
int currentColumn=0;


void basicMidi()
{
	int command=0;
	int x=0;
	int y=0;
	
	serialport_read_until(fd, buf, '\n'); //reading command
	printf("\033[2J");		/* clear screen */
	printf("basicMidi");		 
	
	command = strtol(buf,NULL,10);
	
	serialport_read_until(fd, buf, '\n'); //reading x
	x = strtol(buf,NULL,10);
	
	serialport_read_until(fd, buf, '\n'); //reading y
	y = strtol(buf,NULL,10);
	
#if input_Debug	
	printf("Got %d %d %d\n",command,x,y);
#endif	
	
	//writing back
	sprintf(buf,"%d%d%d\n",command,7-x,y);
#if input_Debug	
	printf("Sending : %s",buf);
#endif	
	rc = serialport_write(fd, buf);
	if(rc==-1)	 {	 printf("ERROR");	 };
	
	_cCoreMIDI->sendShort(endpointRef, 0x90 | 0,notemap[7-x][y], command ? 127:0 );
	
}


void toggleMidi()
{
	int command=0;
	int x=0;
	int y=0;
	
	serialport_read_until(fd, buf, '\n'); //reading command
	printf("\033[2J");		/* clear screen */
	printf("ToggleMIDI");		 
	
	command = strtol(buf,NULL,10);
	
	serialport_read_until(fd, buf, '\n'); //reading x
	x = strtol(buf,NULL,10);
	
	serialport_read_until(fd, buf, '\n'); //reading y
	y = strtol(buf,NULL,10);
	
#if input_Debug	
	printf("Got %d %d %d\n",command,x,y);
#endif	
	
	if(rc==-1)	 {	 printf("ERROR");	 };
	
	if(command ==1)
	{
		if (toggleMp[7-x][y]==0)
			toggleMp[7-x][y]=1;
		
		else if (toggleMp[7-x][y]==1)
			toggleMp[7-x][y]=0;
		
		sprintf(buf,"%d%d%d\n",toggleMp[7-x][y],7-x,y);
#if input_Debug	
		printf("Sending : %s",buf);
#endif	
		rc = serialport_write(fd, buf);
		
		
		_cCoreMIDI->sendShort(endpointRef, 0x90 | 0,notemap[7-x][y], toggleMp[7-x][y]);
		
	}
}

void seq1Input()
{
	
	int command=0;
	int x=0;
	int y=0;
	
	serialport_read_until(fd, buf, '\n'); //reading command
	printf("\033[2J");		/* clear screen */
	printf("seq1Input");		 
	
	command = strtol(buf,NULL,10);
	
	serialport_read_until(fd, buf, '\n'); //reading x
	x = strtol(buf,NULL,10);
	
	serialport_read_until(fd, buf, '\n'); //reading y
	y = strtol(buf,NULL,10);

#if input_Debug	
	printf("Got %d %d %d\n",command,x,y);
#endif	
	if(rc==-1)	 {	 printf("ERROR");	 };
	
	if(command ==1)
	{
		if (toggleMpSeq[7-x][y]==0)
			toggleMpSeq[7-x][y]=1;
		
		else if (toggleMpSeq[7-x][y]==1)
			toggleMpSeq[7-x][y]=0;
		
		sprintf(buf,"%d%d%d\n",toggleMpSeq[7-x][y],7-x,y);
		rc = serialport_write(fd, buf);
		
	}
}

void seq1UI()
{
	
	//toggling column off
	if(firstSeq==true)
	{
		firstSeq=false;
		sprintf(buf,"600\n");
		rc = serialport_write(fd, buf);
	} 
	else
	{
		sprintf(buf,"%d%d%d\n",5,currentColumn,0);
		rc = serialport_write(fd, buf);
		
		//sending midi-off
		for(int i=0;i<8;i++)
		{
			if (toggleMpSeq[currentColumn][i]==1) 
			{ 
				_cCoreMIDI->sendShort(endpointRef, 0x90 | 0,seqMap[i], 0);
			}
			
		}
	}
	
 	
	currentColumn++;
	
	if (currentColumn==8)
	{
		currentColumn=0;
	}
	
	// toggling the new column on
	// sprintf(buf,"%d%d%d\n",5,currentColumn,0); //we cant use this because of the sometimes failure of buttonpress on lighted column.
	// rc = serialport_write(fd, buf);


	//sending midi-on
	for(int i=0;i<8;i++)
	{
		if (toggleMpSeq[currentColumn][i]==1) 
		{ 
			_cCoreMIDI->sendShort(endpointRef, 0x90 | 0,seqMap[i], 127);
		
			//Sometimes when you press on a light when that column is lit, the lights loose their state, thus the code below.
			sprintf(buf,"%d%d%d\n",0,currentColumn,i);
			rc = serialport_write(fd, buf);
		}
		else
		{
			//Sometimes when you press on a light when that column is lit, the lights loose their state, thus the code below.
			sprintf(buf,"%d%d%d\n",1,currentColumn,i);
			rc = serialport_write(fd, buf);
		}
	}
	
	usleep(300000);
}


// The thread entry point routine.
void* PosixThreadMainRoutine(void* data)
{
	while(is_running)
	{
		if(mode == 1)	
			basicMidi();
		if(mode == 2)	
			toggleMidi();
		if(mode == 3)	
			seq1Input();
	}		
    return NULL;
}


// The thread entry point routine.
void* PosixThreadMainRoutine2(void* data)
{
	while(is_running)
	{
		if(mode == 3)	 //
			seq1UI();
	}		
    return NULL;
}



void LaunchThread()
{
    // Create the thread using POSIX routines.
    pthread_attr_t  attr;
    pthread_t       posixThreadID;
	
    assert(!pthread_attr_init(&attr));
    assert(!pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED));
	
    int     threadError = pthread_create(&posixThreadID, &attr, &PosixThreadMainRoutine, NULL);
	
    assert(!pthread_attr_destroy(&attr));
    if (threadError != 0)
    {
		// Report an error.
    }
	
	// Create the thread using POSIX routines.
    pthread_attr_t  attr2;
    pthread_t       posixThreadID2;
	
    assert(!pthread_attr_init(&attr2));
    assert(!pthread_attr_setdetachstate(&attr2, PTHREAD_CREATE_DETACHED));
	
    int     threadError2 = pthread_create(&posixThreadID2, &attr2, &PosixThreadMainRoutine2, NULL);
	
    assert(!pthread_attr_destroy(&attr2));
    if (threadError2 != 0)
    {
		// Report an error.
    }
	
}

void  handleMIDIReceived(const MIDIPacketList *packetList, CCoreMIDIEndpointRef source)
{

/* here i'd like to get the recieved tempo changes and such to matter! */


	/*  
	 vector<MonomeXXhDevice *>::iterator i;
	 
	 for (i = _devices.begin(); i != _devices.end(); i++) {
	 MonomeXXhDevice *device = *i;
	 
	 if (device->MIDIInputDevice() == source) {
	 const MIDIPacket *packet = &packetList->packet[0];
	 
	 for (unsigned int i = 0; i < packetList->numPackets; i++) {
	 unsigned char status, data1, data2, index;
	 
	 index = 0;
	 
	 for (unsigned int j = 0; j < packet->length; j++) {
	 unsigned char midiByte = packet->data[j];
	 
	 switch (index) {
	 case 0:
	 if (midiByte & 0x80) {
	 status = midiByte;
	 index = 1;
	 }
	 
	 break;
	 
	 case 1:
	 if (midiByte & 0x80) {
	 status = midiByte;
	 index = 1;
	 }
	 else {
	 data1 = midiByte;
	 index = 2;
	 }
	 
	 break;
	 
	 case 2:
	 if (midiByte & 0x80) {
	 _handleMIDIMessage(device, status, data1, data2);
	 
	 status = midiByte;
	 index = 1;
	 }
	 else {
	 data2 = midiByte;
	 _handleMIDIMessage(device, status, data1, data2);
	 
	 index = 0;
	 }
	 
	 break;
	 }
	 }
	 
	 if (index != 0)
	 _handleMIDIMessage(device, status, data1, data2);
	 }
	 }
	 }*/
}


static void _ApplicationController_MIDIReceivedCallback(const MIDIPacketList *packetList, void *userData, CCoreMIDIEndpointRef source)
{
	handleMIDIReceived(packetList, source);
}


static void _ApplicationController_MIDISystemStateChangedCallback(const MIDINotification *message, void *userData)
{
	/* handleMIDISystemState(message);*/
}


static void _ApplicationController_MIDIReceivedOnVirtualDestinationCallback(const MIDIPacketList *packetList, void *userData, CCoreMIDIEndpointRef source)
{
	handleMIDIReceived(packetList, source);
}

void blink(int times)
{

for (int i=0;i<times;i++)
{
	sprintf(buf,"610\n");
	rc = serialport_write(fd, buf);
	usleep(300000);	
	sprintf(buf,"600\n");
	rc = serialport_write(fd, buf);
	usleep(300000);	

}

}

int main(int argc, char *argv[]) 
{
	printf("\033[2J");		/* clear screen */
	
	
	string name = "MoanonmeSerial";
    string fromMonomeSerialString = "from moanonme 1";
    string toMonomeSerialString = "to moanonme 1";
	
	printf("Make _cCoreMIDI \n");
	
    _cCoreMIDI = new CCoreMIDI(name);
    _fromMonomeSerial = _cCoreMIDI->createSource(fromMonomeSerialString);
    _toMonomeSerial = _cCoreMIDI->createDestination(toMonomeSerialString, _ApplicationController_MIDIReceivedOnVirtualDestinationCallback, NULL);
	
	_cCoreMIDI->registerForMIDISystemStateChangeNotifications(_ApplicationController_MIDISystemStateChangedCallback, NULL);
	
    if ((endpointRef = _fromMonomeSerial) == 0)
		printf("error");
	
	fd = serialport_init("/dev/tty.usbserial-a40h-666", baudrate);
	if(fd==-1) 
	{
		printf("\033[%d;%dH", 10, 0);			
		printf("NO THAT IS NOT THE PORT YOU'RE WANTING");//bad speling :)
		return -1;
	}
	
	blink(3);	
	
	tem = fcntl(0, F_GETFL, 0);
	fcntl (0, F_SETFL, (tem | O_NDELAY));
	
	LaunchThread();
	
	while (is_running)
	{
		
		
		//check keypress
		n = read(0, &c, 1);
		if (c =='q') 
		{
			is_running=false;
			sprintf(buf,"600\n");
			rc = serialport_write(fd, buf);
		}
		if (c =='1') 
		{
			mode =1;
			sprintf(buf,"600\n");
			rc = serialport_write(fd, buf);
		}
		if (c =='2')  
		{
		mode =2;
			sprintf(buf,"600\n");
			rc = serialport_write(fd, buf);
		}
		if (c =='3')  
		{
			mode =3;
			sprintf(buf,"600\n");//Clear all leds
			firstSeq=true;
			rc = serialport_write(fd, buf);
		}
		
		usleep(1000); //hey man, we dont want to take all CPU, do we?
		
		
	}
 	fcntl(0, F_SETFL, tem);
	
	serialport_write(fd,"600"); //Clear all leds
	printf("Delete _cCoreMIDI \n");
	
	if (_cCoreMIDI != 0)
		delete _cCoreMIDI;
	
	
} // end main




int serialport_writebyte( int fd, uint8_t b)
{
    int n = write(fd,&b,1);
    if( n!=1)
        return -1;
    return 0;
}

int serialport_write(int fd, const char* str)
{
    int len = strlen(str);
    int n = write(fd, str, len);
    if( n!=len ) 
        return -1;
    return 0;
}

int serialport_read_until(int fd, char* buf, char until)
{
    char b[1];
    int i=0;
    do { 
        int n = read(fd, b, 1);  // read a char at a time
        if( n==-1) return -1;    // couldn't read
        if( n==0 ) {
            usleep( 10 * 1000 ); // wait 10 msec try again
            continue;
        }
        buf[i] = b[0]; i++;
    } while( b[0] != until );
	
    buf[i] = 0;  // null terminate the string
    return 0;
}

// takes the string name of the serial port (e.g. "/dev/tty.usbserial","COM1")
// and a baud rate (bps) and connects to that port at that speed and 8N1.
// opens the port in fully raw mode so you can send binary data.
// returns valid fd, or -1 on error
int serialport_init(const char* serialport, int baud)
{
    struct termios toptions;
    int fd;
    
    //fprintf(stderr,"init_serialport: opening port %s @ %d bps\n",
    //        serialport,baud);
	
    fd = open(serialport, O_RDWR | O_NOCTTY | O_NDELAY);
    if (fd == -1)  {
        printf("init_serialport: Unable to open port ");
        return -1;
    }
    
    if (tcgetattr(fd, &toptions) < 0) {
        printf("init_serialport: Couldn't get term attributes");
        return -1;
    }
    speed_t brate = baud; // let you override switch below if needed
    switch(baud) {
		case 4800:   brate=B4800;   break;
		case 9600:   brate=B9600;   break;
#ifdef B14400
		case 14400:  brate=B14400;  break;
#endif
		case 19200:  brate=B19200;  break;
#ifdef B28800
		case 28800:  brate=B28800;  break;
#endif
		case 38400:  brate=B38400;  break;
		case 57600:  brate=B57600;  break;
		case 115200: brate=B115200; break;
    }
    cfsetispeed(&toptions, brate);
    cfsetospeed(&toptions, brate);
	
    // 8N1
    toptions.c_cflag &= ~PARENB;
    toptions.c_cflag &= ~CSTOPB;
    toptions.c_cflag &= ~CSIZE;
    toptions.c_cflag |= CS8;
    // no flow control
    toptions.c_cflag &= ~CRTSCTS;
	
    toptions.c_cflag |= CREAD | CLOCAL;  // turn on READ & ignore ctrl lines
    toptions.c_iflag &= ~(IXON | IXOFF | IXANY); // turn off s/w flow ctrl
	
    toptions.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG); // make raw
    toptions.c_oflag &= ~OPOST; // make raw
	
    // see: http://unixwiz.net/techtips/termios-vmin-vtime.html
    toptions.c_cc[VMIN]  = 0;
    toptions.c_cc[VTIME] = 20;
    
    if( tcsetattr(fd, TCSANOW, &toptions) < 0) {
        printf("init_serialport: Couldn't set term attributes");
        return -1;
    }
	
    return fd;
}

